%
clear;
clc;

% Anfangswert
t0 = 0;
y0 = 5;

% Rechte Seite
f = @(t,y) -2*y;

% Vektor mit Anzahl der verwendeten Schritte
N = 2.^(6:10);

% Ende zeit
T = 5;

% Maximum number of iterations for the corrector
M = 2;

% Bestimme eine Approximation mit AB2 mit N(k) Schritten
error_AM2 = zeros(1,length(N));
for k = 1:length(N)
  [t,yN_approx] = TwoStepAdamsMoulton(f,t0,T,y0,N(k),M);
  
  % Exakte Loesung
  yN_exakt = y0*exp(-2.*t);
  
  % compute error
  error_AM2(k) = abs(yN_approx(end) - yN_exakt(end));
end

loglog (N, error_AM2);
xlim([4e+1,2e+3]);
ylim([1e-10, 1e-6]);
str = sprintf('2-step Adams-Moulton');
title(str);
grid on;

p = polyfit(log(N), log(error_AM2), 1);
convg_order = -p(1);
display(convg_order);
